﻿/*
 * scraep - robust 4chan thread watcher
 * Copyright (C) 2010  ed <tripflag@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License v2
 * (version 2) as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, refer to the following URL:
 * http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
 */
using System;
using System.Collections.Generic;
using System.Text;

namespace scraep {
    class Thread {
        string path;
        public bool dead;
        public string board;
        public long threadid;
        public Image[] images;
        public Thread(string url) {
            string[] derp = { };

            if (url.Contains("?res")) {
                try {
                    string nurl = new System.Net.WebClient().DownloadString(url);
                    string wark = S.splat(nurl, "http://boards.4chan.org/")[1].Split('#')[0];
                    derp = wark.Replace("/res/", "/").Split('/');
                } catch (Exception ex) {
                    derp = new string[] { "0", "0" };
                }

            } else if (url.Contains("/")) {
                url = url.Replace("http://", "");
                derp = url.Split('/');
                derp = new string[] {
                    derp[1], derp[3] };

            } else {
                derp = url.Split('.');
            }
            threadid = Convert.ToInt32(derp[1]);
            board = derp[0];
            path = board + "/" + threadid + "/";
            System.IO.Directory.CreateDirectory(path);
        }
        public bool update() {
            string html = null;
            try {
                //html = new System.Net.WebClient().DownloadString(
                html = Encoding.UTF8.GetString(new System.Net.WebClient().DownloadData(
                    "http://boards.4chan.org/" + board + "/res/" + threadid));
                System.IO.File.WriteAllText(path + "thread.html", html, Encoding.UTF8);
            } catch (Exception ex) {
                dead = ex.Message.Contains("(404)");
                return false;
            }
            string[] img = S.splat(html, "<span class=\"filesize\">");
            if (img.Length < 2) return false;
            List<Image> imagelist = new List<Image>();
            for (int i = 1; i < img.Length; i++) {
                string url = img[i].Split('"')[1];
                string unix = url.Substring(url.LastIndexOf('/') + 1);
                unix = unix.Substring(0, unix.IndexOf("."));

                // thanks a lot moot
                if (url.StartsWith("http")) url = url.Substring(4);
                while (
                    url.StartsWith(":") ||
                    url.StartsWith(".") ||
                    url.StartsWith("/"))
                    url = url.Substring(1);
                url = "http://" + url;

                string md5 = S.tuple(S.tuple(img[i], "\" md5=\"")[1], "\"")[0];
                string fname = S.tuple(S.tuple(img[i], "<span title=\"")[1], "\">")[0];
                fname = fname
                    .Replace('/', '／')
                    .Replace('\\', '／')
                    .Replace(':', '：')
                    .Replace('*', '＊')
                    .Replace('?', '？')
                    .Replace('"', '＂')
                    .Replace('<', '＜')
                    .Replace('>', '＞')
                    .Replace('|', '｜');
                
                imagelist.Add(new Image(url, path + path.Replace('/','.') + unix + "." + fname, md5));
            }
            images = imagelist.ToArray();
            return true;
        }
        public string identifier() {
            return board + "." + threadid;
        }
        public string visual() {
            return "/" + board + "/ " + threadid;
        }
    }
}
